
Declare Reminders = Off
Declare Warnings = Off

'Device = 18F25K20                                '  
Device = 18F2520
Declare Xtal = 8

Config_Start
   OSC = INTIO67
   FCMEN = OFF ; Fail-Safe Clock Monitor disabled
   IESO = OFF ; Oscillator Switchover mode disabled
   PWRT = OFF ; PWRT enabled
   BOREN = OFF ; Brown-out Reset disabled in hardware and software
   WDT = OFF ; WDT disabled (control is placed on the SWDTEN bit)
   MCLRE = OFF ; RE3 input pin enabled; MCLR disabled
   LPT1OSC = OFF ; Timer1 configured for higher power operation
   PBADEN = OFF ; PORTB<4:0> pins are configured as digital I/O on Reset
   CCP2MX = PORTC ; CCP2 input/output is multiplexed with RC1
   STVREN = OFF ; Stack full/underflow will not cause Reset
   LVP = OFF ; Single-Supply ICSP disabled
   XINST = OFF ; Instruction set extension and Indexed Addressing mode disabled (Legacy mode)
   Debug = OFF ; Background debugger disabled, RB6 and RB7 configured as general purpose I/O pins
   CP0 = OFF ; Block 0 (000800-001FFFh) not code-protected
   CP1 = OFF ; Block 1 (002000-003FFFh) not code-protected
   CP2 = OFF ; Block 2 (004000-005FFFh) not code-protected
   CP3 = OFF ; Block 3 (006000-007FFFh) not code-protected
   CPB = OFF ; Boot block (000000-0007FFh) not code-protected
   CPD = OFF ; Data EEPROM not code-protected
   WRT0 = OFF ; Block 0 (000800-001FFFh) not write-protected
   WRT1 = OFF ; Block 1 (002000-003FFFh) not write-protected
   WRT2 = OFF ; Block 2 (004000-005FFFh) not write-protected
   WRT3 = OFF ; Block 3 (006000-007FFFh) not write-protected
   WRTB = OFF ; Boot block (000000-0007FFh) not write-protected
   WRTC = OFF ; Configuration registers (300000-3000FFh) not write-protected
   WRTD = OFF ; Data EEPROM not write-protected
   EBTR0 = OFF ; Block 0 (000800-001FFFh) not protected from table reads executed in other blocks
   EBTR1 = OFF ; Block 1 (002000-003FFFh) not protected from table reads executed in other blocks
   EBTR2 = OFF ; Block 2 (004000-005FFFh) not protected from table reads executed in other blocks
   EBTR3 = OFF ; Block 3 (006000-007FFFh) not protected from table reads executed in other blocks
   EBTRB = OFF ; Boot block (000000-0007FFh) not protected from table reads executed in other blocks
Config_End

OSCCON = %01110110
OSCTUNE = %011111
Include "Timer0.inc"

OpenTimer0(TIMER_INT_ON  & T0_8BIT & T0_SOURCE_INT & T0_PS_1_256)
'--------------------------    ------------------------
                                                         
Declare  LCD_Type   ALPHA               '   -  -
Declare  LCD_DTPin  PORTB.4             '   
Declare  LCD_ENPin  PORTB.3             '   E
Declare  LCD_RSPin  PORTB.2             '   RS
Declare  LCD_Interface  4               '   
Declare  LCD_CommandUs  2000            '    
Declare  LCD_DataUs  200               '    
Declare  LCD_Lines   4                  '    


'--------------------------   ---------------------------------                                                                  
PortB_Pullups = OFF                     '     PORTB
TRISA = %11111111
'porta = 0
TRISB = %00000011
LATB = %00000000
TRISC = %00000000
LATC = %00000000
'--------------------------
Dim   BIG             As  Dword         '    
Dim   BIG1            As  BIG.HighWord  '                                        '
Dim   Sec             As  Byte          '
Dim   Minute          As  Byte          '
Dim   Hour            As  Byte          '
'----------------------------------------------------------------------------------
Symbol BUT   = PORTB.1 '
Symbol LED   = PORTC.7 '
'--------------------------  TMR0   --------------------

INTCONbits_T0IE = 1                            '   
BIG = 2000000
INTCONbits_GIE = 1                             ' Enable global interrupts 
On_Hardware_Interrupt GoTo  Int_Label
PORTB.1 = 0
Clear 
'--------------------------
main:
 
'If PORTB.1 = 1 Then DelayMS 200 : LED = 0 ' 
If PORTB.1 = 0 Then DelayMS 200 : LED = 1 '

If Sec > 59 Then Sec = 0 : Inc Minute : LED = 0  '  60  ,     ,   
If Minute = 59 Then Minute = 0 : Inc Hour               '  60  ,    0 ,   

Print At 1, 1 , Dec2 Hour, ":", Dec2 Minute , ":" , Dec2 Sec'   


GoTo main
'--------------------------  --------------------------
Int_Label:                                          ' 
Context Save                                        '    

If INTCONbits_T0IF = 1 Then Dec BIG1	            '   TMR0,        BIG1, 
                                                    '   ,    65536  BIG,    
If BIG < 0 Then BIG = BIG + 2000000 : Inc Sec       '  BIG < 0    ,     
                                                    '  1000000 
INTCONbits_T0IF = 0                                            '    

Context Restore  
